## singleapplication 3.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.0)

project(SingleApplication LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

add_library(${PROJECT_NAME} STATIC
    singleapplication.cpp
    singleapplication_p.cpp
)
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

if(NOT QT_DEFAULT_MAJOR_VERSION)
    set(QT_DEFAULT_MAJOR_VERSION 5 CACHE STRING "Qt version to use (5 or 6), defaults to 5")
endif()

# Find dependencies
set(QT_COMPONENTS Core Network)
set(QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Core Qt${QT_DEFAULT_MAJOR_VERSION}::Network)

if(QAPPLICATION_CLASS STREQUAL QApplication)
    list(APPEND QT_COMPONENTS Widgets)
    list(APPEND QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Widgets)
elseif(QAPPLICATION_CLASS STREQUAL QGuiApplication)
    list(APPEND QT_COMPONENTS Gui)
    list(APPEND QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Gui)
else()
    set(QAPPLICATION_CLASS QCoreApplication)
endif()

find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED)

target_link_libraries(${PROJECT_NAME} PUBLIC ${QT_LIBRARIES})

if(WIN32)
    target_link_libraries(${PROJECT_NAME} PRIVATE advapi32)
endif()

target_compile_definitions(${PROJECT_NAME} PUBLIC QAPPLICATION_CLASS=${QAPPLICATION_CLASS})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

## singleapplication 3.1.4

=== debian/changelog ===
singleapplication (3.1.4-2) unstable; urgency=medium

  * Source-only upload for testing migration. 
  * debian/control: Use "Rules-Requires-Root: no".

 -- Boyuan Yang <byang@debian.org>  Fri, 24 Jul 2020 11:08:02 -0400

singleapplication (3.1.4-1) unstable; urgency=medium

  [ Guobang Bi ]
  * New upstream version 3.1.4

 -- Guobang Bi <ymshenyu@gmail.com>  Wed, 15 Jul 2020 13:30:18 +0800

singleapplication (3.1.3.1-2) unstable; urgency=medium

  [ Guobang Bi ]
  * fix upstream-metadata-missing-bug-tracking lintian warning
  * fix executable-not-elf-or-script lintian warning
  * New upstream version 3.1.4

 -- Guobang Bi <ymshenyu@gmail.com>  Wed, 15 Jul 2020 13:22:51 +0800

singleapplication (3.1.3.1-1) unstable; urgency=medium

  * Initial release

 -- Guobang Bi <ymshenyu@gmail.com>  Tue, 02 Jun 2020 15:34:06 +0800

=== debian/control ===
Source: singleapplication
Priority: optional
Maintainer: Guobang Bi <ymshenyu@gmail.com>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.7.0~),
 debhelper-compat (= 13),
 qtbase5-dev,
Standards-Version: 4.5.0
Section: libs
Rules-Requires-Root: no
Homepage: https://github.com/itay-grudev/SingleApplication
Vcs-Git: https://salsa.debian.org/debian/singleapplication.git
Vcs-Browser: https://salsa.debian.org/debian/singleapplication

Package: libsingleapplication-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: Replacement of QtSingleApplication for Qt5
 Project SingleApplication is a replacement of QtSingleApplication
 for Qt5. It helps to keep the primary instance of your application
 and kill each subsequent instances. If enabled, it can also spawn
 secondary (non-related to the primary) instances and send data to
 the primary instance from secondary instances.

## singleapplication 3.2.0

=== debian/changelog ===
singleapplication (3.2.0-2) unstable; urgency=medium

  * debian/libsingleapplication-dev.install: Correct install dir
    to fix FTBFS on i386. Thanks to Pino Toscano!

 -- Boyuan Yang <byang@debian.org>  Sat, 06 Feb 2021 10:15:24 -0500

singleapplication (3.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 08 Jan 2021 21:59:11 -0500

=== debian/control ===
--- 
+++ 
@@ -1,4 +1,5 @@
 Source: singleapplication
+Section: libs
 Priority: optional
 Maintainer: Guobang Bi <ymshenyu@gmail.com>
 Uploaders:
@@ -7,8 +8,7 @@
  cmake (>= 3.7.0~),
  debhelper-compat (= 13),
  qtbase5-dev,
-Standards-Version: 4.5.0
-Section: libs
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/itay-grudev/SingleApplication
 Vcs-Git: https://salsa.debian.org/debian/singleapplication.git

## singleapplication 3.3.2

=== debian/changelog ===
singleapplication (3.3.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.

  [ Boyuan Yang ]
  * New upstream release 3.3.2.

 -- Boyuan Yang <byang@debian.org>  Thu, 25 Nov 2021 18:39:59 -0500

singleapplication (3.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 29 Sep 2021 20:50:33 -0400

singleapplication (3.3.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 15 Aug 2021 12:31:39 -0400

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  cmake (>= 3.7.0~),
  debhelper-compat (= 13),
  qtbase5-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/itay-grudev/SingleApplication
 Vcs-Git: https://salsa.debian.org/debian/singleapplication.git

## singleapplication 3.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.7.0)
+cmake_minimum_required(VERSION 3.12.0)
 
 project(SingleApplication LANGUAGES CXX)
 
@@ -38,3 +38,13 @@
 
 target_compile_definitions(${PROJECT_NAME} PUBLIC QAPPLICATION_CLASS=${QAPPLICATION_CLASS})
 target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
+target_compile_definitions(${PROJECT_NAME} PRIVATE
+    QT_NO_CAST_TO_ASCII
+    QT_NO_CAST_FROM_ASCII
+    QT_NO_URL_CAST_FROM_STRING
+    QT_NO_CAST_FROM_BYTEARRAY
+    QT_USE_QSTRINGBUILDER
+    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
+    QT_NO_KEYWORDS
+    QT_NO_FOREACH
+)

=== debian/changelog ===
singleapplication (3.3.4-2) unstable; urgency=medium

  * QA upload.
  * Orphan the package.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Update standards version to 4.6.2, no changes needed.
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on cmake.

 -- Boyuan Yang <byang@debian.org>  Thu, 29 Feb 2024 13:37:32 -0500

singleapplication (3.3.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Add missing build-dependency dh-exec.

 -- Boyuan Yang <byang@debian.org>  Mon, 11 Apr 2022 13:06:25 -0400

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: singleapplication
 Section: libs
 Priority: optional
-Maintainer: Guobang Bi <ymshenyu@gmail.com>
-Uploaders:
- Boyuan Yang <byang@debian.org>,
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends:
- cmake (>= 3.7.0~),
+ cmake,
  debhelper-compat (= 13),
+ dh-exec,
  qtbase5-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/itay-grudev/SingleApplication
 Vcs-Git: https://salsa.debian.org/debian/singleapplication.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND =

export QT_SELECT := 5

%:
	dh $@

## singleapplication 3.5.4+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12.0)

project(SingleApplication VERSION 3.6.0 LANGUAGES CXX DESCRIPTION "Replacement for QtSingleApplication")

set(CMAKE_AUTOMOC ON)

add_library(${PROJECT_NAME} STATIC
    singleapplication.cpp
    singleapplication_p.cpp
)

# User configurable options
if(NOT QT_DEFAULT_MAJOR_VERSION)
    set(QT_DEFAULT_MAJOR_VERSION 5 CACHE STRING "Qt version to use (5 or 6), defaults to 5")
endif()

if(NOT QAPPLICATION_CLASS)
    set(QAPPLICATION_CLASS QCoreApplication CACHE STRING "Qt application base class or FreeStandingSingleApplication")
endif()

option(SINGLEAPPLICATION_INSTALL OFF "Enable freestanding mode install including config files")

if(SINGLEAPPLICATION_INSTALL AND NOT QAPPLICATION_CLASS STREQUAL "FreeStandingSingleApplication")
    message(FATAL_ERROR "SINGLEAPPLICATION_INSTALL requires QAPPLICATION_CLASS == FreeStandingSingleApplication")
endif()

# Find dependencies
set(QT_COMPONENTS Core Network)
set(QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Core Qt${QT_DEFAULT_MAJOR_VERSION}::Network)

if(QAPPLICATION_CLASS STREQUAL QApplication)
    list(APPEND QT_COMPONENTS Widgets)
    list(APPEND QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Widgets)
elseif(QAPPLICATION_CLASS STREQUAL QGuiApplication)
    list(APPEND QT_COMPONENTS Gui)
    list(APPEND QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Gui)
endif()

find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED)

option(SINGLEAPPLICATION_DOCUMENTATION "Generate Doxygen documentation" OFF)
if(SINGLEAPPLICATION_DOCUMENTATION)
    find_package(Doxygen)
endif()

target_link_libraries(${PROJECT_NAME} PUBLIC ${QT_LIBRARIES})

if(WIN32)
    target_link_libraries(${PROJECT_NAME} PRIVATE advapi32)
endif()

if(SINGLEAPPLICATION_INSTALL)
    target_compile_definitions(${PROJECT_NAME} PRIVATE QAPPLICATION_CLASS=${QAPPLICATION_CLASS})
    target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
    target_include_directories(${PROJECT_NAME} INTERFACE $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
else()
    target_compile_definitions(${PROJECT_NAME} PUBLIC QAPPLICATION_CLASS=${QAPPLICATION_CLASS})
    target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
endif()

target_compile_definitions(${PROJECT_NAME} PRIVATE
    QT_NO_CAST_TO_ASCII
    QT_NO_CAST_FROM_ASCII
    QT_NO_URL_CAST_FROM_STRING
    QT_NO_CAST_FROM_BYTEARRAY
    QT_USE_QSTRINGBUILDER
    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    QT_NO_KEYWORDS
    QT_NO_FOREACH
)

if(DOXYGEN_FOUND)
    # Doxygen theme
    include(FetchContent)
    FetchContent_Declare(DoxygenAwesome
        GIT_REPOSITORY https://github.com/jothepro/doxygen-awesome-css
        GIT_TAG 4cd62308d825fe0396d2f66ffbab45d0e247724c # 2.0.3
    )
    FetchContent_MakeAvailable(DoxygenAwesome)
    FetchContent_GetProperties(DoxygenAwesome SOURCE_DIR DoxygenAwesome_SOURCE_DIR)

    set(DOXYGEN_USE_MDFILE_AS_MAINPAGE README.md)
    set(DOXYGEN_GENERATE_TREEVIEW YES)
    set(DOXYGEN_HTML_HEADER ${DoxygenAwesome_SOURCE_DIR}/doxygen-custom/header.html)
    set(DOXYGEN_HTML_EXTRA_STYLESHEET ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome.css)
    set(DOXYGEN_HTML_EXTRA_FILES
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-fragment-copy-button.js
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-paragraph-link.js
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-darkmode-toggle.js
    )

    doxygen_add_docs(${PROJECT_NAME}Documentation
        singleapplication.h
        CHANGELOG.md
        Windows.md
        README.md
    )
endif()

if(SINGLEAPPLICATION_INSTALL)
    # Create a header veriant where QAPPLICATION_CLASS is replaced with FreeStandingSingleApplication
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/singleapplication.h" SINGLEAPPLICATION_H_CONTENT)

    string(REGEX REPLACE
        "#ifndef QAPPLICATION_CLASS[^\n]*\n[ \t]*#define QAPPLICATION_CLASS QCoreApplication[^\n]*\n[ \t]*#endif[^\n]*\n"
        ""
        SINGLEAPPLICATION_H_CONTENT
        "${SINGLEAPPLICATION_H_CONTENT}")

    string(REGEX REPLACE
        "#include QT_STRINGIFY\\(QAPPLICATION_CLASS\\)"
        "#include \"FreeStandingSingleApplication\""
        SINGLEAPPLICATION_H_CONTENT
        "${SINGLEAPPLICATION_H_CONTENT}")

    string(REPLACE
        "QAPPLICATION_CLASS"
        "FreeStandingSingleApplication"
        SINGLEAPPLICATION_H_CONTENT
        "${SINGLEAPPLICATION_H_CONTENT}")

    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/singleapplication.h" "${SINGLEAPPLICATION_H_CONTENT}")

    # CMake install
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/singleapplication.h" "SingleApplication" "FreeStandingSingleApplication"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

    include(CMakePackageConfigHelpers)
    write_basic_package_version_file(
        "SingleApplicationConfigVersion.cmake"
        VERSION "${PACKAGE_VERSION}"
        COMPATIBILITY SameMajorVersion)

    configure_file("SingleApplicationConfig.cmake.in" "SingleApplicationConfig.cmake" @ONLY)
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/SingleApplicationConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/SingleApplicationConfigVersion.cmake"
        DESTINATION "lib/cmake/SingleApplication")

    install(TARGETS SingleApplication EXPORT SingleApplicationTargets)
    install(EXPORT SingleApplicationTargets
        FILE "SingleApplicationTargets.cmake"
        NAMESPACE "SingleApplication::"
        DESTINATION "lib/cmake/SingleApplication")
else()
    add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
endif()

=== debian/changelog ===
singleapplication (3.5.4+ds-1) unstable; urgency=medium

  * QA upload.
  * New upstream release. (Closes: #1050520)
  * debian/copyright: Update information and exclude examples/ directory.
  * debian/examples: Dropped.
  * debian/control: Bump Standards-Version to 4.7.2.
  * debian/control: Move package description to source package section.

 -- Boyuan Yang <byang@debian.org>  Sat, 25 Oct 2025 11:01:34 -0400

=== debian/control ===
Source: singleapplication
Section: libs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-exec,
 qtbase5-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/itay-grudev/SingleApplication
Vcs-Git: https://salsa.debian.org/debian/singleapplication.git
Vcs-Browser: https://salsa.debian.org/debian/singleapplication
Description: Replacement of QtSingleApplication for Qt5
 Project SingleApplication is a replacement of QtSingleApplication
 for Qt5. It helps to keep the primary instance of your application
 and kill each subsequent instances. If enabled, it can also spawn
 secondary (non-related to the primary) instances and send data to
 the primary instance from secondary instances.

Package: libsingleapplication-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%singleapplication-$1.tar.gz%" \
   https://github.com/itay-grudev/SingleApplication/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
